-- (c) David Cunningham 2009, Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php

include "common/map_classes.lua"

include "common/phys_mats.lua"

material "common/Ogre/HeadEarring" { diffuseColour = {1,1,0} }
material "common/Ogre/HeadSkin" { diffuseMap = "./HeadSkin.jpg" }
material "common/Ogre/HeadTusks" { diffuseMap = "./HeadTusks.jpg" }
material "common/Ogre/HeadEyes" { diffuseMap = "./HeadEyes.png" }
material "common/Ogre/Robot" { diffuseMap = "./Robot.jpg" }

material "common/Barrier/Cone" { specularity=5, specularColour={0.5,0.5,0.5}, specularMap="./TrafficCone_spec.dds", diffuseMap = "./TrafficCone.dds" }
material "common/Barrier/Tyre" { diffuseMap = "./Tyre.png" }
streamer:addClass("common/Barrier/TrafficCone",ColClass,{renderingDistance=100,castShadows=true})
streamer:addClass("common/Barrier/Tyre",ColClass,{renderingDistance=200,castShadows=true})
streamer:addClass("common/Barrier/Cube1",ColClass,{renderingDistance=200,castShadows=true})
streamer:addClass("common/Barrier/Cube2",ColClass,{renderingDistance=200,castShadows=true})

material "common/Bowling/Pin" { diffuseMap = "./Pin.dds" }
material "common/Bowling/Ball" { diffuseMap="./Ball.dds", specularColour={.5,.5,.5}, specularity=20 }
streamer:addClass("common/Bowling/Ball",ColClass,{renderingDistance=100,castShadows=true})
streamer:addClass("common/Bowling/Pin",ColClass,{renderingDistance=100,castShadows=true})

material "common/CannonBall/Black" { diffuseColour={.05,.05,.05}, specularColour={1,1,1}, specularity=20 }
streamer:addClass("common/CannonBall/15cm",ColClass,{renderingDistance=100,castShadows=true})

material "common/Crate/Small" { diffuseMap = "./side.dds" }
material "common/Crate/Big" { diffuseMap = "./red_side.dds", normalMap = "./red_side_N.dds", specularMap="./red_side_S.dds" }
--material "common/Crate/Big" { diffuseMap = "./red_side.dds" }
material "common/Crate/Long" { specularColour={.7,.7,1}, diffuseMap = "./Panel_Diffuse.dds", normalMap = "./Panel_Normal.png" }
--material "common/Crate/Long" { diffuseMap = "./blue_side.dds" }
streamer:addClass("common/Crate/Small",ColClass,{renderingDistance=30,castShadows=true})
streamer:addClass("common/Crate/Big",ColClass,{renderingDistance=70,castShadows=true})
streamer:addClass("common/Crate/Long",ColClass,{renderingDistance=100,castShadows=true})

material "common/Jenga/Brick" { specularColour={.7,.7,.7}, specularMap="./Brick.dds", diffuseMap = "./Brick.dds" }
streamer:addClass("common/Jenga/Brick",ColClass,{renderingDistance=50,castShadows=true})

include "common/Particle/init.lua"

function make_lots_of_robots(xmin,xmax,xspc,ymin,ymax,yspc,height)
    xmin = xmin or -1000
    xmax = xmax or 1000
    xspc = xspc or 100
    ymin = ymin or -1000
    ymax = ymax or 1000
    yspc = yspc or 100
    height = height or 0
    for x=xmin,xmax,xspc do
        for y=ymin,ymax,yspc do
            local n=sm.root:createChild()
            n.position=Vector3(x,y,height)
            n.orientation = Q_UP
            n:attachObject(sm:createEntity(x..","..y,"common/Ogre/Robot.mesh"))
        end
    end
end
