-- (c) David Cunningham 2009, Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php

--[[
dynamics: restitution, friction, tyre_grip, all_terrain_tyre_grip, wet_factor
graphics: skidmarks, sparks, footprints, foot dust, wheelprints, skid marks, wheel dust, wheelspin smoke, bullet_dust
props: list of various props with flags and whatever
character_controller: camera_collision, max_incline, can_run,
sound: footsteps, bangs, scrapes, bullet_ricochets,
gameplay: bullets_penetrate, flammability,
]]--

Frictionless = 0
Rubber = 1
Metal = 2
Plastic = 3
PolishedWood = 4
PolishedStone = 5
Wood = 6
Stone = 7
Mud = 8
Gravel = 9
Sand = 10

PhysMat = PhysMat or { }
PhysMat.roadTyreFriction = PhysMat.roadTyreFriction or { }
PhysMat.offRoadTyreFriction = PhysMat.offRoadTyreFriction or { }

FrictionlessGroup = { Frictionless }
StickyGroup = { Rubber }
SmoothHardGroup = { PolishedWood, PolishedStone }
SmoothSoftGroup = { Metal, Plastic}
RoughGroup = { Wood, Stone, Mud, Gravel, Sand }

-- give friction and restitution for each pair
pw:setMaterialInteraction(FrictionlessGroup, FrictionlessGroup, 0, 0)
pw:setMaterialInteraction(FrictionlessGroup, StickyGroup, 0, 0)
pw:setMaterialInteraction(FrictionlessGroup, SmoothHardGroup, 0, 0)
pw:setMaterialInteraction(FrictionlessGroup, SmoothSoftGroup, 0, 0)
pw:setMaterialInteraction(FrictionlessGroup, RoughGroup, 0, 0)

pw:setMaterialInteraction(StickyGroup, StickyGroup, 1, 0.15)
pw:setMaterialInteraction(StickyGroup, SmoothHardGroup, 1, 0.15)
pw:setMaterialInteraction(StickyGroup, SmoothSoftGroup, 1, 0.05)
pw:setMaterialInteraction(StickyGroup, RoughGroup, 1, 0.05)

pw:setMaterialInteraction(SmoothHardGroup, SmoothHardGroup, 0.2, 0.5)
pw:setMaterialInteraction(SmoothHardGroup, SmoothSoftGroup, 0.2, 0.25)
pw:setMaterialInteraction(SmoothHardGroup, RoughGroup, 0.5, 0.25)

pw:setMaterialInteraction(SmoothSoftGroup, SmoothSoftGroup, 0.2, 0.0)
pw:setMaterialInteraction(SmoothSoftGroup, RoughGroup, 0.5, 0.0)

pw:setMaterialInteraction(RoughGroup, RoughGroup, 0.8, 0)

MuddyGroup = { Frictionless, Mud, Gravel, Sand }
SolidSmoothGroup = { Metal, Plastic, PolishedWood, PolishedStone }
SolidRoughGroup = { Rubber, Wood, Stone }

for _,v in ipairs(MuddyGroup) do
    PhysMat.roadTyreFriction[v] = 0.5
    PhysMat.offRoadTyreFriction[v] = 1.5
end

for _,v in ipairs(SolidSmoothGroup) do
    PhysMat.roadTyreFriction[v] = 1.1
    PhysMat.offRoadTyreFriction[v] = 0.9
end

for _,v in ipairs(SolidRoughGroup) do
    PhysMat.roadTyreFriction[v] = 1.5
    PhysMat.offRoadTyreFriction[v] = 1.3
end
