-- (c) David Cunningham 2009, Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php

add_resource_location("earth/earth_tex_dds_uncompressed.zip","Zip",false)
add_resource_location("earth/earth_lo_0.zip","Zip",false)
add_resource_location("earth/earth_lo_1.zip","Zip",false)

--optional!
add_resource_location("earth/earth_hi_00.zip","Zip",false)
add_resource_location("earth/earth_hi_01.zip","Zip",false)
add_resource_location("earth/earth_hi_02.zip","Zip",false)
add_resource_location("earth/earth_hi_03.zip","Zip",false)
add_resource_location("earth/earth_hi_04.zip","Zip",false)
add_resource_location("earth/earth_hi_05.zip","Zip",false)
add_resource_location("earth/earth_hi_06.zip","Zip",false)
add_resource_location("earth/earth_hi_07.zip","Zip",false)
add_resource_location("earth/earth_hi_08.zip","Zip",false)
add_resource_location("earth/earth_hi_09.zip","Zip",false)
add_resource_location("earth/earth_hi_10.zip","Zip",false)

--mlockall()

initialise_all_resource_groups()

if not already_setup_earth then
        gfx.cam.nearClipDistance = 0.4
        gfx.cam.farClipDistance = 2000
        sm.shadowTechnique = "NONE"
        already_setup_earth = true
end

sm:setAmbientLight(0.1,0.1,0.1)
sm:setFog("EXP2",0.7137,0.533,0.4,0.0008,0,0)
gfx.sun.direction = Vector3(1,-1,-1).normalised
gfx.sun:setDiffuseColour(0.9,0.9,0.9)

set_texture_budget(128*1024*1024)
set_mesh_budget(128*1024*1024)

function latlong (east,south)
        local real = Vector3(86400*0.500,43200*0.500,0)*Vector3((east)/360,(-south)/180,0)
        local ogre = earth_node.derivedOrientation * (real*earth_node.derivedScale) + earth_node.derivedPosition 
        return ogre
end

function name (x,y,prefix)
        prefix = prefix or "earth."
        --local x2, y2 = x * 675, y * 675
        local x2, y2 = x, y
        return prefix..string.format("%03d",x2).."."..string.format("%02d",y2)
end

local base = get_material("base")
local base2 = get_material("base'")

for y=0,63 do
        for x=0,127 do
                local tex_name = name(x,y,"earth.")..".dds"
                local mname = name(x,y,"earth_hi.")

                for _,mat  in ipairs{mname,mname.."'"} do
                        local m = get_material(mat)
                        if m ~= nil then remove_material(mat) end
                        m = base:clone(mat)
                        base = base2
                        for t=0,m:getNumTechniques()-1 do
                                m:setTextureName(t,0,0,tex_name)
                                if mat:sub(-1) == "'" then
                                        m:setDepthWriteEnabled(t,0,false)
                                end
                        end
                end
        end
end

function get (x,y)
        return streamer:getObject(name(x,y))
end

streamer:addClass("earth/Piece", BaseClass, {
        renderingDistance=500;
        init = function (persistent)
                local x, y = persistent.col, persistent.row
                persistent.gfxMesh = name(x,y,"earth_hi.")..".mesh"
                persistent:hintAdvancePrepare("Texture", name(x,y,"earth.")..".dds")
                persistent.pos = Vector3(x-64+0.5,32-y-0.5,0)*675*0.5
                persistent:updateSphere(persistent.pos.x, persistent.pos.y, persistent.pos.z, persistent.renderingDistance)
                BaseClass.init(persistent)
        end;
})

streamer:addClass("earth/LODPiece", BaseClass, {
        renderingDistance=1500;
        init = function (persistent)
                local x, y = persistent.col, persistent.row
                persistent.gfxMesh = name(x,y,"earth_lo.")..".mesh"
                persistent:hintAdvancePrepare("Texture", name(x,y,"earth.")..".dds")
                persistent.pos = Vector3(x-64+0.5,32-y-0.5,0)*675*0.5
                persistent:updateSphere(persistent.pos.x, persistent.pos.y, persistent.pos.z, persistent.renderingDistance)
                BaseClass.init(persistent)
        end;
})

function add (x,y)
        local last
        if resource_exists(name(x,y,"earth_hi.")..".mesh") then
                last=streamer:addObject("earth/Piece",x,y,0,{col=x,row=y})
        end
        streamer:addObject("earth/LODPiece",x,y,0,{near=last,col=x,row=y})
end

function add_all ()
        for y=0,63 do
                for x=0,127 do
                        add(x,y)
                end
        end
end

add_all()

-- vim: shiftwidth=8:tabstop=8:expandtab
