// (c) David Cunningham 2009, Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php

uniform float desaturation;
uniform sampler LeftTex : TEXUNIT0;
uniform sampler RightTex : TEXUNIT1;

void fp_main (
        in float2 tex_coord : TEXCOORD0,
        out float4 pixel : COLOR
) {

        float3 bias = float3(1, 1, 1) / 3.0;

        float3 left_tex = tex2D(LeftTex, tex_coord).rgb;
        float3 left_eye = lerp(left_tex,float3(1,1,1) * dot(left_tex,bias), desaturation);

        float3 right_tex = tex2D(RightTex, tex_coord).rgb;
        float3 right_eye = lerp(right_tex,float3(1,1,1) * dot(right_tex,bias), desaturation);

        pixel = float4(left_eye.r, right_eye.gb, 1);

}

// vim: ts=8:sw=8:et
