local mu_front = 1.2
local mu_back = .93
local rad = 0.29 -- wheels
local len = 0.1
local wx, wf, wb, wz = 0.67, 1.375, -1.115, -0.10

streamer:addClass("vehicles/Focus", extends(Vehicle) {
        gfxMesh="vehicles/Focus/Body.mesh",
        colMesh="vehicles/Focus/Body.tcol",
        powerPlots = {
                [-1] = { [0] = -1000; [15] = -3000; [30] = -2000; [40] = -1000; },
                [0] = {}, --neutral
                [1] = { [0] = 8000; [10] = 8000; [20] = 6000; [40] = 6000; [80] = 6000; [100] = 5000 ; [110] = 4000; [150] = 2000; },
        },       
        wheelInfo = {
                {pos=Vector3(-wx, wf, wz);
                 left=true; steer=1; drive=1; handbrake=false;
                 mesh="vehicles/Focus/Wheel.mesh"; len=len; rad=rad;
                 mu = mu_front;
                },

                {pos=Vector3(wx, wf, wz);
                 left=false; steer=1; drive=1; handbrake=false;
                 mesh="vehicles/Focus/Wheel.mesh"; len=len; rad=rad;
                 mu = mu_front
                },

                {pos=Vector3(-wx, wb, wz);
                 left=true; steer=0; drive=false; handbrake=true;
                 mesh="vehicles/Focus/Wheel.mesh"; len=len; rad=rad;
                 mu = mu_back
                },

                {pos=Vector3(wx, wb, wz);
                 left=false; steer=0; drive=false; handbrake=true;
                 mesh="vehicles/Focus/Wheel.mesh"; len=len; rad=rad;
                 mu = mu_back
                },
        },
},{})

streamer:addClass("vehicles/FocusChassis", ColClass, { gfxMesh="vehicles/Focus/Body.mesh", colMesh="vehicles/Focus/Body.tcol" })

material "vehicles/Focus/Body" { diffuseMap = "./Body.jpg"; specularColour = {.1, .1, .1}; specularity = 20; }
material "vehicles/Focus/Wheel" { diffuseMap = "./Body.jpg"; }

-- vim: shiftwidth=8:tabstop=8:expandtab
